#ifndef BENCHMARK_GETMICROSECONDS_MAXINTERVAL
  #define BENCHMARK_GETMICROSECONDS_MAXINTERVAL 5
#endif // #ifndef BENCHMARK_GETMICROSECONDS_MAXINTERVAL

#import "winmm.dll"
  uint timeBeginPeriod( uint );
//  uint timeEndPeriod( uint );
  uint timeGetTime( void );
#import

class MICROSECONDS
{
  static const bool IsNotChanged;

  static ulong GetInterval( void )
  {
    uint TickCount = 0;
    const uint PrevTickCount = winmm::timeGetTime();
    const ulong StartTime = ::GetMicrosecondCount();

    do
    {
      TickCount = winmm::timeGetTime();
    } while ((TickCount == PrevTickCount));

    return(::GetMicrosecondCount() - StartTime);
  }

  static ulong GetAvgInterval( const int Amount = 10 )
  {
    MICROSECONDS::GetInterval(); // 

    ulong Sum = 0;

    for (int i = 0; i < Amount; i++)
      Sum += MICROSECONDS::GetInterval();

    return(Sum / Amount);
  }

  static ulong GetAvgIntervalMcs( const int Attempts = 10 )
  {
    const ulong StartTime = ::GetMicrosecondCount();
    ulong NewTime = StartTime;

    for (int i = 0; i < Attempts; i++)
      NewTime = ::GetMicrosecondCount();

    return((NewTime - StartTime) / Attempts);
  }

  static bool IsChange( const int Amount = 10 )
  {
  #ifdef GetMicrosecondCount
    ::Alert(__FILE__ + ": #" + "ifdef GetMicrosecondCount - true!");
  #endif // #ifdef GetMicrosecondCount

    const ulong AvgIntervalMcs = MICROSECONDS::GetAvgIntervalMcs(Amount);
    bool Res = (AvgIntervalMcs > (BENCHMARK_GETMICROSECONDS_MAXINTERVAL));

    if (Res)
    {
      ::Alert(__FILE__ + ": FreezeVPS - TimeAvg[GetMicrosecondsCount()] = " + (string)AvgIntervalMcs + " mcs.");

      winmm::timeBeginPeriod(1);

      const ulong AvgInterval = MICROSECONDS::GetAvgInterval(Amount);

      if (Res = (AvgInterval < 1500)) //     : https://www.mql5.com/ru/forum/352454#comment_18584321
        ::Alert(__FILE__ + ": AvgInterval = " + (string)AvgInterval + " mcs. Replacement: GetMicrosecondCount -> winmm::timeGetTime.");
      else
        ::Alert(__FILE__ + ": AvgInterval = " + (string)AvgInterval + " mcs. GetMicrosecondCount is not changed. See winmm::timeBeginPeriod(1).");
    }

    return(Res);
  }

public:
  static ulong Get( void )
  {
    return(MICROSECONDS::IsNotChanged ? ::GetMicrosecondCount() : ((ulong)winmm::timeGetTime() * 1000));
  }
};

static const bool MICROSECONDS::IsNotChanged = !MICROSECONDS::IsChange();

#ifdef GetMicrosecondCount
  #undef GetMicrosecondCount
#endif // #ifdef GetMicrosecondCount

#define GetMicrosecondCount MICROSECONDS::Get